<?php

/**
 * titulo_minero actions.
 * Se deja por vista, de igual forma usa el id_debito de la tabla DEBITO_REF,
 * Ya que en la tabla de rmn_titulo no estan todos los titulos de Cartera - 20160216
 *
 * @package    cobro_coactivo
 * @subpackage titulo_minero
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class titulo_mineroActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_TITULO_MINERO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_TITULO_MINERO_V' =>
        array(
            'cod_titulo' => 'cod_titulo',
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral',
            'num_doc_deb' => 'num_doc_deb',
            'razon_soc_deb' => 'razon_soc_deb',
            'mail_deb' => 'mail_deb'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_TITULO_MINERO_V' =>
        array(
            'cod_titulo,a' => array('!=' => array(-1)),
            'cod_titulo,b' => array('=' => array('cod_titulo')),
            'mineral' => array('=' => array('mineral')),
            'id_debito' => array('=' => array('id_debito')),
            'id_mineral' => array('=' => array('id_mineral')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'CBR_TITULO_MINERO_V' =>
        array(
            'cod_titulo' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeList2(sfWebRequest $request) {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejar Errores
         */
        try {

            /*
             * Variables para el registro de log
             */

            //1 - indica operacion de consulta
            $id_ope_bd = 1;

            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_debito_ref');


            //CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, $observacion);

            /*
             * Filtro para que levante por CO_ESTUDIOS_PREVIOS y por FASE
             */

            $whereTituloMinero = "";
            $whereIdTituloMinero = "";

            if (isset($request['id_debito'])) {
                $whereTituloMinero = "AND tab0.id_debito=" . $request['id_debito'];
            }

            if (isset($request['titulo'])) {
                $whereTituloMinero.="AND tab0.titulo LIKE '" . $request['titulo'] . "%'";
            }

            //Se agrega filtro de id_titulo_minero para mayor eficiencia - 20160210
            if (isset($request['id_titulo_minero'])) {
                $whereIdTituloMinero.="AND tab0.id_titulo_minero = " . $request['id_titulo_minero'];
            }

            //filtro de titulo, se agrega busqueda en minuscula/mayuscula - 20160210
            if (isset($request['input'])) {
                $whereTituloMinero.="AND tab0.titulo LIKE upper('%" . $request['input'] . "%')";
            }

            /*
             * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
             */
            $sql = <<<EOD
SELECT tab0.*
                    
from(
    select tab0.id_referencia2 as titulo, tab1.descripcion as mineral, 
    max(tab0.id_debito) as id_titulo_minero
    from ca_debito_ref tab0
    left join re_mineral tab1 ON tab1.id_mineral = tab0.id_referencia1               
    group by tab0.id_referencia2, tab1.descripcion
)tab0                      

where 
1 = 1 
$whereIdTituloMinero                    
$whereTituloMinero

order by tab0.titulo                     
EOD;
            $records = CN_TABLE::executeSQL($sql);

            //Ejecuta sql
            $this->totalRows = count($records);
            $this->list_data = $records;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
